typedef union{
  struct{ 
          int label; 
        } labeled_form;
  struct{
          char identifier[IDENTIFIER_LENGTH+1];
          int label;
        } binding_form;
  struct{
          char identifier[IDENTIFIER_LENGTH+1];
          int label;
          int order; /* IDENTIFIER, INFIX_OPERATOR_LEFT,
                        INFIX_OPERATOR_RIGHT, or POSTFIX_OPERATOR */
          int precedence;
        } binding_form_pos;
  struct{
          char identifier[IDENTIFIER_LENGTH+1];
          int label;
          type_t type;
        } binding_form_with_type;
  struct{
          char identifier[IDENTIFIER_LENGTH+1];
          int label;
          int order; /* IDENTIFIER, INFIX_OPERATOR_LEFT,
                        INFIX_OPERATOR_RIGHT, or POSTFIX_OPERATOR */
          int precedence;
          type_t type;
        } binding_form_pos_with_type;
  struct{ 
          buffer_t buffer; 
          environment_id environment;
          type_t type;
        } typed_expression;
  struct{
          type_t type;
          int size;
        } expression_with_type_and_size;
  struct{
          type_t pattern_type;
          type_t expression_type;
        } double_typed_expression;
  struct{
          int bindings_no;
        } multibinding_form;
  struct{
          char identifier[IDENTIFIER_LENGTH+1];
        } just_an_identifier;
  type_t type_expression;
} YYSTYPE;
#define	LOWEST_PRECEDENCE	257
#define	C_OBJECT	258
#define	C_FUNCTION	259
#define	C_ACTION	260
#define	C_FUNCTION_TO_ACTION	261
#define	ABSTRACT	262
#define	CONCRETE	263
#define	TYPE	264
#define	EXCEPTION	265
#define	ASSERT	266
#define	IN	267
#define	DEBUG	268
#define	THROW	269
#define	INTO	270
#define	THROW_IO	271
#define	IMPOSSIBLE	272
#define	IMPOSSIBLE_IO	273
#define	TRY	274
#define	CATCH	275
#define	TRY_IO	276
#define	CATCH_IO	277
#define	BEGIN_IO	278
#define	END_IO	279
#define	MAKE_IO	280
#define	ASSIGN	281
#define	TAKES	282
#define	SKIP	283
#define	ELSE	284
#define	IF	285
#define	THEN	286
#define	MATCH	287
#define	WITH	288
#define	PIPE	289
#define	UNDERSCORE	290
#define	AMPERSAND	291
#define	POSTFIX_OPERATOR_1	292
#define	INFIX_OPERATOR_LEFT_1	293
#define	INFIX_OPERATOR_RIGHT_1	294
#define	FIX	295
#define	LET	296
#define	LETREC	297
#define	POSTFIX_OPERATOR_2	298
#define	INFIX_OPERATOR_LEFT_2	299
#define	INFIX_OPERATOR_RIGHT_2	300
#define	BE	301
#define	COLON	302
#define	POSTFIX_OPERATOR_3	303
#define	INFIX_OPERATOR_LEFT_3	304
#define	INFIX_OPERATOR_RIGHT_3	305
#define	LAMBDA	306
#define	DOT	307
#define	EQUAL	308
#define	DIFFERENT	309
#define	LESS	310
#define	GREATER	311
#define	LESS_OR_EQUAL	312
#define	GREATER_OR_EQUAL	313
#define	EQUAL_FLOAT	314
#define	DIFFERENT_FLOAT	315
#define	LESS_FLOAT	316
#define	GREATER_FLOAT	317
#define	LESS_OR_EQUAL_FLOAT	318
#define	GREATER_OR_EQUAL_FLOAT	319
#define	EQUAL_STRING	320
#define	DIFFERENT_STRING	321
#define	LESS_STRING	322
#define	GREATER_STRING	323
#define	LESS_OR_EQUAL_STRING	324
#define	GREATER_OR_EQUAL_STRING	325
#define	EQUAL_BOOLEAN	326
#define	DIFFERENT_BOOLEAN	327
#define	EQUAL_CHARACTER	328
#define	DIFFERENT_CHARACTER	329
#define	LESS_CHARACTER	330
#define	GREATER_CHARACTER	331
#define	LESS_OR_EQUAL_CHARACTER	332
#define	GREATER_OR_EQUAL_CHARACTER	333
#define	POSTFIX_OPERATOR_4	334
#define	INFIX_OPERATOR_LEFT_4	335
#define	INFIX_OPERATOR_RIGHT_4	336
#define	VOID_CONSTANT	337
#define	INTEGER_CONSTANT	338
#define	STRING_CONSTANT	339
#define	CHARACTER_CONSTANT	340
#define	FLOAT_CONSTANT	341
#define	POSTFIX_OPERATOR_5	342
#define	INFIX_OPERATOR_LEFT_5	343
#define	INFIX_OPERATOR_RIGHT_5	344
#define	ARROW	345
#define	UNARY_MINUS	346
#define	UNARY_PLUS	347
#define	POSTFIX_OPERATOR_6	348
#define	INFIX_OPERATOR_LEFT_6	349
#define	INFIX_OPERATOR_RIGHT_6	350
#define	COMMA	351
#define	PLUS	352
#define	MINUS	353
#define	PLUS_FLOAT	354
#define	MINUS_FLOAT	355
#define	TIMES	356
#define	DIVIDED	357
#define	MODULO	358
#define	TIMES_FLOAT	359
#define	DIVIDED_FLOAT	360
#define	MODULO_FLOAT	361
#define	POSTFIX_OPERATOR_7	362
#define	INFIX_OPERATOR_LEFT_7	363
#define	INFIX_OPERATOR_RIGHT_7	364
#define	CONS	365
#define	POSTFIX_OPERATOR_8	366
#define	INFIX_OPERATOR_LEFT_8	367
#define	INFIX_OPERATOR_RIGHT_8	368
#define	OPEN_PAR	369
#define	CLOSE_PAR	370
#define	OPEN_BRACKET	371
#define	CLOSE_BRACKET	372
#define	OPEN_ARRAY	373
#define	CLOSE_ARRAY	374
#define	EMPTY_LIST	375
#define	POSTFIX_OPERATOR_9	376
#define	INFIX_OPERATOR_LEFT_9	377
#define	INFIX_OPERATOR_RIGHT_9	378
#define	IDENTIFIER	379
#define	INFIX_OPERATOR_LEFT	380
#define	INFIX_OPERATOR_RIGHT	381
#define	POSTFIX_OPERATOR	382
#define	CONSTRUCTOR	383
#define	ABSTRACT_TYPE_NAME	384
#define	CONCRETE_TYPE_NAME	385
#define	EXCEPTION_NAME	386
#define	GENERIC	387
#define	TRUE	388
#define	FALSE	389
#define	APPLICATION	390
#define	POSTFIX_OPERATOR_10	391
#define	INFIX_OPERATOR_LEFT_10	392
#define	INFIX_OPERATOR_RIGHT_10	393
#define	OR	394
#define	OR_STRICT	395
#define	XOR	396
#define	AND	397
#define	AND_STRICT	398
#define	DEFINE	399
#define	UNDEFINE	400
#define	IMPORTATION	401
#define	UNIMPORTATION	402
#define	DECLARE	403
#define	POSTFIX_OPERATOR_11	404
#define	INFIX_OPERATOR_LEFT_11	405
#define	INFIX_OPERATOR_RIGHT_11	406
#define	SEMICOLON	407
#define	POSTFIX_OPERATOR_12	408
#define	INFIX_OPERATOR_LEFT_12	409
#define	INFIX_OPERATOR_RIGHT_12	410
#define	CONCATENATE_STRING	411
#define	CONCATENATE_ARRAY	412
#define	VOID	413
#define	INTEGER	414
#define	FLOAT	415
#define	STRING	416
#define	CHARACTER	417
#define	C_TYPE	418
#define	BOOLEAN	419
#define	IO	420
#define	ARRAY	421
#define	LIST	422
#define	PROMISE	423
#define	POSTFIX_OPERATOR_13	424
#define	INFIX_OPERATOR_LEFT_13	425
#define	INFIX_OPERATOR_RIGHT_13	426
#define	OF	427
#define	POSTFIX_OPERATOR_14	428
#define	INFIX_OPERATOR_LEFT_14	429
#define	INFIX_OPERATOR_RIGHT_14	430
#define	FROM	431
#define	TO	432
#define	FROM_ARRAY	433
#define	TO_ARRAY	434
#define	AT_STRING	435
#define	LENGTH_STRING	436
#define	AT_ARRAY	437
#define	LENGTH_ARRAY	438
#define	CHARACTER_TO_INTEGER	439
#define	INTEGER_TO_CHARACTER	440
#define	CHARACTER_TO_STRING	441
#define	ARRAY_TO_LIST	442
#define	LIST_TO_ARRAY	443
#define	POSTFIX_OPERATOR_15	444
#define	INFIX_OPERATOR_LEFT_15	445
#define	INFIX_OPERATOR_RIGHT_15	446
#define	EMPTY	447
#define	HEAD	448
#define	TAIL	449
#define	POSTFIX_OPERATOR_16	450
#define	INFIX_OPERATOR_LEFT_16	451
#define	INFIX_OPERATOR_RIGHT_16	452
#define	INTEGER_TO_FLOAT	453
#define	FLOAT_TO_INTEGER	454
#define	POWER	455
#define	POWER_FLOAT	456
#define	FORCE	457
#define	DELAY	458
#define	POSTFIX_OPERATOR_17	459
#define	INFIX_OPERATOR_LEFT_17	460
#define	INFIX_OPERATOR_RIGHT_17	461
#define	NOT	462
#define	POSTFIX_OPERATOR_18	463
#define	INFIX_OPERATOR_LEFT_18	464
#define	INFIX_OPERATOR_RIGHT_18	465
#define	PRED	466
#define	SUCC	467
#define	POSTFIX_OPERATOR_19	468
#define	INFIX_OPERATOR_LEFT_19	469
#define	INFIX_OPERATOR_RIGHT_19	470
#define	SELECTOR	471
#define	POSTFIX	472
#define	INFIX	473
#define	LEFT	474
#define	RIGHT	475
#define	POSTFIX_OPERATOR_20	476
#define	INFIX_OPERATOR_LEFT_20	477
#define	INFIX_OPERATOR_RIGHT_20	478
#define	SCAN_ERROR	479
#define	HIGHEST_PRECEDENCE	480


extern YYSTYPE yylval;
