/* This file is part of GNU epsilon, a functional language implementation

Copyright (C) 2003 Luca Saiu

GNU epsilon is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2, or (at your
option) any later version.

GNU epsilon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with epsilon; see the file COPYING.  If not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA. */


#include "../eam_types.h"

/* "Convert" a float_t into a word_t (which always have the same size), leaving
   the bit-pattern untouched: */
word_t float_to_word(float_t f){
  return *((word_t*)&f);
}

/* "Convert" a word_t into a float_t (which always have the same size), leaving
   the bit-pattern untouched: */
float_t word_to_float(word_t p){
  return *((float_t*)&p);
}

/* Used in use_everything.c */
integer_t float_constant = 10;
